package org.xtext.example.mydsl7.serializer;

import com.google.inject.Inject;
import com.google.inject.Provider;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.serializer.acceptor.ISemanticSequenceAcceptor;
import org.eclipse.xtext.serializer.acceptor.SequenceFeeder;
import org.eclipse.xtext.serializer.diagnostic.ISemanticSequencerDiagnosticProvider;
import org.eclipse.xtext.serializer.diagnostic.ISerializationDiagnostic.Acceptor;
import org.eclipse.xtext.serializer.sequencer.AbstractDelegatingSemanticSequencer;
import org.eclipse.xtext.serializer.sequencer.GenericSequencer;
import org.eclipse.xtext.serializer.sequencer.ISemanticNodeProvider.INodesForEObjectProvider;
import org.eclipse.xtext.serializer.sequencer.ISemanticSequencer;
import org.eclipse.xtext.serializer.sequencer.ITransientValueService;
import org.eclipse.xtext.serializer.sequencer.ITransientValueService.ValueTransient;
import org.xtext.example.mydsl7.myDsl7.Greeting7;
import org.xtext.example.mydsl7.myDsl7.Model7;
import org.xtext.example.mydsl7.myDsl7.MyDsl7Package;
import org.xtext.example.mydsl7.services.MyDsl7GrammarAccess;

@SuppressWarnings("all")
public class MyDsl7SemanticSequencer extends AbstractDelegatingSemanticSequencer {

	@Inject
	private MyDsl7GrammarAccess grammarAccess;
	
	public void createSequence(EObject context, EObject semanticObject) {
		if(semanticObject.eClass().getEPackage() == MyDsl7Package.eINSTANCE) switch(semanticObject.eClass().getClassifierID()) {
			case MyDsl7Package.GREETING7:
				if(context == grammarAccess.getGreeting7Rule()) {
					sequence_Greeting7(context, (Greeting7) semanticObject); 
					return; 
				}
				else break;
			case MyDsl7Package.MODEL7:
				if(context == grammarAccess.getModel7Rule()) {
					sequence_Model7(context, (Model7) semanticObject); 
					return; 
				}
				else break;
			}
		if (errorAcceptor != null) errorAcceptor.accept(diagnosticProvider.createInvalidContextOrTypeDiagnostic(semanticObject, context));
	}
	
	/**
	 * Constraint:
	 *     name=ID
	 */
	protected void sequence_Greeting7(EObject context, Greeting7 semanticObject) {
		if(errorAcceptor != null) {
			if(transientValues.isValueTransient(semanticObject, MyDsl7Package.Literals.GREETING7__NAME) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, MyDsl7Package.Literals.GREETING7__NAME));
		}
		INodesForEObjectProvider nodes = createNodeProvider(semanticObject);
		SequenceFeeder feeder = createSequencerFeeder(semanticObject, nodes);
		feeder.accept(grammarAccess.getGreeting7Access().getNameIDTerminalRuleCall_1_0(), semanticObject.getName());
		feeder.finish();
	}
	
	
	/**
	 * Constraint:
	 *     greetings+=Greeting7*
	 */
	protected void sequence_Model7(EObject context, Model7 semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
}
